#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fftw.h>
#include <math.h>
#include <gaussian.h>

int get_var(const char *source, char *dest, const char *var);
int decode_hex (const char *hex, char *des);

char astring [1024], *ptr;

int logmessage(char *s){
  FILE *f;
  f = fopen("log.log", "a");
  fprintf(f, "%s", s);
  fclose(f);
  return 0;
}

int get_var(const char *source, char *dest, const char *var)
{
int c;
char i;
int size;
char *p_copy;
p_copy=(char *) strstr(source, var);
if (p_copy) ;
else /* A test for a Null pointer. If one is there, it is a checkbox which
is off */
        {
        return(-1);
        }
size = strlen (var);
i=0;
c=0;
while (i != '&')
{
        i = *(p_copy+size+c);

        switch(i)
                {
                case '+':
                *(dest+c) = ' ';
                c++;
                break;
                case '&':
                break;
                case '%':
                if (decode_hex((p_copy+size+c), &i))
                        *(dest+c) = i;
                i= '$';
                p_copy += 2;
                c++;
                break;
                default:
                *(dest+c) = i;
                c++;
                break;
                } /*end switch*/
} /* end while */
*(dest+c) = '\0';
return (c);
}

/*      decode_hex takes a pointer to the spot in the array to decode and
a pointer to the destination
        Added 3/7/96 at 1:30am )1996 Brant Sears
*/

int decode_hex (const char *hex, char *des)
{
char string[3];
int i;
long l;
if ((sscanf(hex, "%%%2s", string))==0)
        return(0);
l=strtol(string, NULL, 16);
i = (int) l;
*des = (char) i;
return(1);
}


int main(int argc, char *argv[]) {
    char query[512], buf [512], s[32];
    char covtype;
    int n1, n2, nlevels, i, j, ncols;
    double dsum;
    double pct[16];
    int col[16];
    char colnames[256];
    int red[16], green[16], blue[16];
    float t1, t2;
    double theta[2];
    int we_have_query, error_query;
    int *r, *g, *b;
    double *c;
    FILE *counterfile;
    long filenamebase;
    char filename[256], clippedfilename[256], numfilename[256],
         clippednumfilename[256];
    int response;
    char fileformat;
    char levelsformat;
    int scale;
    int zoom;
    long int counter;

ncols=14;
strcpy (&(colnames[0]), "Black");
red[0]=0;
green[0]=0;
blue[0]=0;
strcpy (&(colnames[15*1]), "Dark Gray");
red[1]=100;
green[1]=99;
blue[1]=100;
strcpy (&(colnames[15*2]), "Light Gray");
red[2]=193;
green[2]=193;
blue[2]=193;
strcpy (&(colnames[15*3]), "White");
red[3]=255;
green[3]=255;
blue[3]=255;
strcpy (&(colnames[15*4]), "Light Green");
red[4]=109;
green[4]=204;
blue[4]=61;
strcpy (&(colnames[15*5]), "Forest Green");
red[5]=37;
green[5]=105;
blue[5]=37;
strcpy (&(colnames[15*6]), "Orange");
red[6]=236;
green[6]=91;
blue[6]=40;
strcpy (&(colnames[15*7]),"Red");
red[7]= 176;
green[7]=28;
blue[7]=25;
strcpy (&(colnames[15*8]), "Magenta");
red[8]=199;
green[8]=0;
blue[8]=201;
strcpy (&(colnames[15*9]), "Cyan");
red[9]=0;
green[9]=192;
blue[9]=201;
strcpy (&(colnames[15*10]), "Light Blue");
red[10]=101;
green[10]=178;
blue[10]=232;
strcpy (&(colnames[15*11]), "Dark Blue");
red[11]=35;
green[11]=46;
blue[11]=106;
strcpy (&(colnames[15*12]), "Yellow");
red[12]=241;
green[12]=235;
blue[12]=52;
strcpy (&(colnames[15*13]), "Brown");
red[13]=201;
green[13]=107;
blue[13]=6;

 r=(int *) malloc(16*sizeof(int));
 g=(int *) malloc(16*sizeof(int));
 b=(int *) malloc(16*sizeof(int));
 c=(double *) malloc(16*sizeof(double));
printf("Content-type: text/html\n\n");
we_have_query = 0;
if ((getenv ("QUERY_STRING") != NULL) && (getenv ("QUERY_STRING")[0]!=0)){
  strcpy (query, getenv ("QUERY_STRING"));
  if (strlen(query)>3){
    query [strlen (query)]='&';
    get_var (query, buf,"r=");
    covtype=buf[0];
    get_var (query, buf,"n1=");
    n1 = strtol (buf, (char **)NULL, 0);
    get_var (query, buf,"n2=");
    n2 = strtol (buf, (char **)NULL, 0);
    get_var (query, buf,"t1=");
    sscanf (buf, "%f", &t1);
    get_var (query, buf,"t2=");
    sscanf (buf, "%f", &t2);
    get_var (query, buf,"nlevels=");
    nlevels = strtol (buf, (char **)NULL, 0);
    get_var (query, buf,"ff=");
    fileformat=buf[0];
    if ((fileformat != '3') && (fileformat != 'Z')) fileformat='3';
    get_var (query, buf,"l=");
    levelsformat=buf[0];
    if ((levelsformat != 'i') && (fileformat != 'n')) levelsformat='n';
    get_var (query, buf,"scale=");
    scale = strtol (buf, (char **)NULL, 0);
    if ((scale!=0) && (scale!=1)) scale=0;
    if (nlevels>14) nlevels=14;
    if (nlevels==0) nlevels=3;
    we_have_query = 1;
    for (i=0; i<nlevels; i++) {
     sprintf (s, "col%d=", i);
     get_var (query, buf, s);
     for (j=0; j<ncols; j++){
       if (strcmp(buf, &(colnames[j*15]))==0) break;
     }
     col[i]=j;
    }
    for (i=0; i<nlevels-1; i++) {
     sprintf (s, "pct%d=", i);
     get_var (query, buf, s);
     sscanf (buf, "%lf", &pct[i]);
    }
    error_query=0;
    if ((n1==0) || (n2==0) || (t1==0) || (t2==0)) error_query=1;
    dsum=0;
    for (i=0;i<nlevels-1;i++) dsum += pct[i];
    if (dsum>=100) error_query=2;
  }
  else {
    nlevels=strtol (query, (char **)NULL, 0);
    if (nlevels>14) nlevels=14;
    if (nlevels==0) nlevels=3;
    n1=256;
    n2=256;
    t1=10;
    t2=2;
    for (i=0; i<nlevels; i++){
      col[i]=i;
      pct[i]=(double)100/nlevels;
    }
    covtype='m';
    fileformat='3';
    levelsformat='n';
    scale=0;
  }
 }
 else {
  n1=256;
  n2=256;
  t1=10;
  t2=2;
  nlevels=3;
  covtype='m';
  fileformat='3';
  levelsformat='n';
  for (i=0; i<nlevels; i++){
      pct[i]=(double)100/nlevels;
    }
  col[0]=6;
  col[1]=12;
  col[2]=7;
  scale=0;
}

/* begin make html file */
printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n");
printf("<html>\n");
printf("  <head>\n");
printf("    <title>Gaussian random field generator</title>\n");
printf("  </head>\n");
printf("  <body bgcolor=\"#cbd6da\" text=\"#000000\" link=\"#0000ff\" vlink=\"#0000ff\" alink=\"#0000ff\">\n");
printf("    <center><H1>Clipped Gaussian Random Fields</H1>\n");
printf("    <a href=\"http://www.lastrada.net\">Boris Kozintsev</a>, <a href=\"http://www.math.umd.edu/~bnk\">Benjamin Kedem</a>,\n");
printf("    <a href=\"http://www.math.umd.edu\">Department of Mathematics</a>, <a href=\"http://www.maryland.edu\">University of Maryland</a>, 1999.</center>\n");
printf("    <hr size=2>\n");
printf("    <form method=GET action=\"generate.cgi#image\">\n");
printf("      <table cellpadding=5>\n");
printf("         <tr>\n");
printf("             <td width=\"47%%\" valign=top>\n");
printf("               <p><b><font color=\"#008000\">Covariance function family:</font></b></p>\n");
switch (covtype) {
 case 'r':
           printf("               <input type=radio name=r value=mat>\n");
           printf("               <a href=\"correlations/mat.html\">Matrn</a><p>\n");
           printf("               <input type=radio name=r value=sph>\n");
           printf("               <a href=\"correlations/sph.html\">Spherical</a><p>\n");
           printf("               <p><input type=radio name=r value=exp>\n");
           printf("               <a href=\"correlations/exp.html\">Exponential</a><p>\n");
           printf("               <input type=radio checked name=r value=rat>\n");
           printf("               <a href=\"correlations/rat.html\">Rational Quadratic</a><p>\n");
           printf("               <input type=radio name=r value=cus>\n");
           printf("               <a href=\"correlations/custom.html\">Custom</a><p>\n");
           break;
 case 'm':
           printf("               <input type=radio checked name=r value=mat>\n");
           printf("               <a href=\"correlations/mat.html\">Matrn</a><p>\n");
           printf("               <input type=radio name=r value=sph>\n");
           printf("               <a href=\"correlations/sph.html\">Spherical</a><p>\n");
           printf("               <p><input type=radio name=r value=exp>\n");
           printf("               <a href=\"correlations/exp.html\">Exponential</a><p>\n");
           printf("               <input type=radio name=r value=rat>\n");
           printf("               <a href=\"correlations/rat.html\">Rational Quadratic</a><p>\n");
           printf("               <input type=radio name=r value=cus>\n");
           printf("               <a href=\"correlations/custom.html\">Custom</a><p>\n");
           break;
 case 's':
           printf("               <input type=radio name=r value=mat>\n");
           printf("               <a href=\"correlations/mat.html\">Matrn</a><p>\n");
           printf("               <input type=radio checked name=r value=sph>\n");
           printf("               <a href=\"correlations/sph.html\">Spherical</a><p>\n");
           printf("               <p><input type=radio name=r value=exp>\n");
           printf("               <a href=\"correlations/exp.html\">Exponential</a><p>\n");
           printf("               <input type=radio name=r value=rat>\n");
           printf("               <a href=\"correlations/rat.html\">Rational Quadratic</a><p>\n");
           printf("               <input type=radio name=r value=cus>\n");
           printf("               <a href=\"correlations/custom.html\">Custom</a><p>\n");
           break;
case 'c':
           printf("               <input type=radio name=r value=mat>\n");
           printf("               <a href=\"correlations/mat.html\">Matrn</a><p>\n");
           printf("               <input type=radio name=r value=sph>\n");
           printf("               <a href=\"correlations/sph.html\">Spherical</a><p>\n");
           printf("               <p><input type=radio name=r value=exp>\n");
           printf("               <a href=\"correlations/exp.html\">Exponential</a><p>\n");
           printf("               <input type=radio name=r value=rat>\n");
           printf("               <a href=\"correlations/rat.html\">Rational Quadratic</a><p>\n");
           printf("               <input type=radio checked name=r value=cus>\n");
           printf("               <a href=\"correlations/custom.html\">Custom</a><p>\n");
           break;
default:
           printf("               <input type=radio name=r value=mat>\n");
           printf("               <a href=\"correlations/mat.html\">Matrn</a><p>\n");
           printf("               <input type=radio name=r value=sph>\n");
           printf("               <a href=\"correlations/sph.html\">Spherical</a><p>\n");
           printf("               <p><input type=radio checked name=r value=exp>\n");
           printf("               <a href=\"correlations/exp.html\">Exponential</a><p>\n");
           printf("               <input type=radio name=r value=rat>\n");
           printf("               <a href=\"correlations/rat.html\">Rational Quadratic</a><p>\n");
           printf("               <input type=radio name=r value=cus>\n");
           printf("               <a href=\"correlations/custom.html\">Custom</a><p>\n");
}
printf("               <p><b><font color=\"#008000\">Covariance parameters:</font></b></p>\n");
printf("               Theta<sub>1</sub> = <input name=t1 value=%3.3f SIZE=8><p>\n", t1);
printf("               Theta<sub>2</sub> = <input name=t2 value=%3.3f SIZE=8><p>\n", t2);
switch (fileformat){
   case '3':
     printf("               <p><b><font color=\"#008000\">File format:</font></b></p>\n");
     printf("               <input type=radio checked name=ff value=3>\n");
     printf("               X Y Z values<p>\n");
     printf("               <input type=radio name=ff value=Z>\n");
     printf("               Z values only (row-wise)<p>\n");
     break;
   case 'Z':
     printf("               <p><b><font color=\"#008000\">Numerical file format:</font></b></p>\n");
     printf("               <input type=radio name=ff value=3>\n");
     printf("               X Y Z values<p>\n");
     printf("               <input type=radio checked name=ff value=Z>\n");
     printf("               Z values only (row-wise)<p>\n");
     break;
}
printf("             </td>\n");
printf("             <td width=\"50%%\" valign=top>\n");
printf("               <p><b><font color=\"#008000\">Expected color areas for clipping:</font></b></p>\n");
for (i=0; i < nlevels-1; i++) {
  printf("               <p><select name=col%d size=1>\n", i);
  for (j=0; j<ncols; j++) {
    printf("                    <option>%s</option>\n", &colnames[(j+col[i])%ncols*15]);
  }
  printf("               </select> -- \n");
  printf("               <input name=pct%d value=%f SIZE=4> Percent </p>\n", i, pct[i]);
}
  printf("               <p><select name=col%d size=1>\n", i);
  for (j=0; j<ncols; j++) {
    printf("                    <option>%s</option>\n", &colnames[(j+col[i])%ncols*15]);
  }
  printf("               </select> -- Remaining area\n");
  printf("               <font size=-1>\n");
  printf("               <br><br>To get different number of colors, say <i>n</i>,\n");
  printf("               use http://www.math.umd.edu/~bnk/bak/generate.cgi?n\n");
  printf("               </font></p>\n");
  if (levelsformat=='i') {
     printf("               <input type=radio name=l value=n>\n");
     printf("               Set thresholds based on normal quantiles<p>\n");
     printf("               <input type=radio name=l checked value=i>\n");
     printf("               Set thresholds based on actual realization<p>\n");
  } else {
     printf("               <input type=radio name=l checked value=n>\n");
     printf("               Set thresholds based on normal quantiles<p>\n");
     printf("               <input type=radio name=l value=i>\n");
     printf("               Set thresholds based on actual realization<p>\n");
    }
  printf("               <p><b><font color=\"#008000\">Image size:</font></b></p>\n");
  printf("               <input name=n1 value=%d SIZE=4> x ", n1);
  printf("               <input name=n2 value=%d SIZE=4>\n", n2);
  printf("               <input name=nlevels value=%d type=HIDDEN>\n", nlevels);
  if (scale)
     printf("               <p><input name=scale value=1 type=checkbox checked> Zoom small images");
  else
     printf("               <p><input name=scale value=1 type=checkbox> Zoom small images");
  printf("               <p><input type=submit value=\"Generate!\">\n");
  printf("             </td>\n");
  printf("         </tr>\n");
   printf("      </table>\n");
  printf("    </form>\n");
 if (we_have_query){
  i = time(0);
  logmessage(ctime ((const time_t *)&i));
  if  (getenv("REMOTE_HOST") != NULL) {
    sprintf (buf, "REMOTE_HOST: %s\n",  getenv("REMOTE_HOST"));
    logmessage (buf);
  }
  if  (getenv("REMOTE_ADDR") != NULL) {
    sprintf (buf, "REMOTE_ADDR: %s\n",  getenv("REMOTE_ADDR"));
    logmessage (buf);
  }
  if  (getenv("HTTP_USER_AGENT") != NULL) {
    sprintf (buf, "HTTP_USER_AGENT: %s\n",  getenv("HTTP_USER_AGENT"));
    logmessage (buf);
  }
  sprintf (buf, "QUERY_STRING: %s\n",  getenv("QUERY_STRING"));
  logmessage (buf);
  printf("    <a name=image></a>\n");
  if (error_query==1)
   printf ("    <b><font color=\"#ff0000\">Error: all parameters must be positive.</font></b>\n");
  else if (error_query==2)
   printf ("    <b><font color=\"#ff0000\">Error: percentages do not sum up correctly.</font></b>\n");
  else {
    dsum=0;
    if (levelsformat=='n')
      for (i=0;i<nlevels-1; i++) {
         c[i]=PhiInv(pct[i]/100.0+dsum);
         dsum += pct[i]/100.0;
      }
    else for (i=0;i<nlevels-1; i++) c[i]=pct[i]/100.0;
    for (i=0;i<nlevels; i++){
      r[i]=red[col[i]];
      g[i]=green[col[i]];
      b[i]=blue[col[i]];
    }
    srand48(time(NULL));
    filenamebase = lrand48();
    sprintf (filename, "%ld.ppm", filenamebase);
    sprintf (clippedfilename, "%ld_clp.ppm",filenamebase);
    sprintf (numfilename, "%ld.txt",filenamebase);
    sprintf (clippednumfilename, "%ld_clp.txt",filenamebase);
    counter=0;
    counterfile=fopen("counter.g", "r");
    if (counterfile) {
       fscanf (counterfile,"%ld", &counter);
       fclose(counterfile);
    }
    counterfile=fopen("counter.g", "w");
    fprintf (counterfile,"%ld", ++counter);
    fclose(counterfile);
    if (!(counter % 10)) {
       /*system("/usr/ucb/mail bak@math.umd.edu < log.log");*/
       system("/usr/bin/rm -f *.gif *.ppm *.txt *.log");
    }
    theta[0]=t1;
    theta[1]=t2;
    response= write_field (
                  n1,        /*for generating*/
                  n2,        /*for generating*/
                  n1,        /*output window size*/
                  n2,        /*output window size*/
                  &theta[0],
                  covtype,
                  filename,
                  numfilename,
                  clippedfilename,
                  clippednumfilename,
                  fileformat,
                  nlevels-1,
                  r, g, b, c, levelsformat=='n');
    if ((response==-1) && ((n1<256) || (n2 < 256))) {
       response= write_field (
                  256,        /*for generating*/
                  256,        /*for generating*/
                  n1,        /*output window size*/
                  n2,        /*output window size*/
                  &theta[0],    /*parameters*/
                  covtype,
                  filename,
                  numfilename,
                  clippedfilename,
                  clippednumfilename,
                  fileformat,
                  nlevels-1,
                  r, g, b, c, levelsformat=='n');
        if (response==-2) response=-1;
    }
    switch(response)     {
     case 0:
       logmessage("RESULT: success\n\n");
       if (scale && (n1<256) && (n2 < 256))
                     zoom = (n1>n2)?256/n1:256/n2;
       else zoom=1;
       printf("    <center>\n");
       printf("      <b><font color=\"#008000\">A realization:</font></b><p>\n");
       printf("      <table border=12 cellpadding=0 valign=center>\n");
       printf("        <tr>\n");
       printf("           <td align=center><img src=\"showppm.cgi?%ld\" alt=\"Gaussian Random Field\" width=%d height=%d></td>\n",
         filenamebase, n2*zoom, n1*zoom);
       printf("           <td align=center><img src=\"showppm.cgi?%ld_clp\" alt=\"Quantized Into %d Categories\" width=%d height=%d></td>\n",
          filenamebase, nlevels, n2*zoom, n1*zoom);
       printf("        </tr>\n");
       printf("        <tr>\n");
       printf("           <td>");
       printf("             <a href=%s>%s</a>",numfilename,numfilename);
       printf("           </td>");
       printf("           <td align=right>");
       printf("             <a href=%s>%s</a>",clippednumfilename, clippednumfilename);
       printf("           </td>");
       printf("        </tr>\n");
       printf("      </table>\n");
       printf("    </center>\n");
       break;
     case -1:
       logmessage("RESULT: negative embedding\n\n");
       printf ("       <b><font color=\"#ff0000\">Error: can't use these covariance parameters (non-positive embedding).</font>\n");
       printf ("       Increase image size or adjust parameters so that the covariance between points on the opposite sides of the image is zero.</b>\n");
       printf ("       <center>\n");
       printf ("       <b><br>These parameters work for 256x256 images:</b><br>\n");
       printf ("       <table border=1 cellpadding=20>\n");
       printf ("          <tr>\n");
       printf ("              <td></td>\n");
       printf ("              <td bgcolor=\"#70db93\">Theta<sub>1</sub></td>\n");
       printf ("              <td bgcolor=\"#70db93\">Theta<sub>2</sub></td>\n");
       printf ("          </tr>\n");
       printf ("          <tr>\n");
       printf ("              <td bgcolor=\"#70db93\">Matrn</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">10</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">2</td>\n");
       printf ("          </tr>\n");
       printf ("          <tr>\n");
       printf ("              <td bgcolor=\"#70db93\">Spherical</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">256</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">&nbsp</td>\n");
       printf ("          </tr>\n");
       printf ("          <tr>\n");
       printf ("              <td bgcolor=\"#70db93\">Exponential</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">0.9</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">0.8</td>\n");
       printf ("          </tr>\n");
       printf ("          <tr>\n");
       printf ("              <td bgcolor=\"#70db93\">Rational Quadratic</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">1.6</td>\n");
       printf ("              <td bgcolor=\"#ccffff\">1.1</td>\n");
       printf ("          </tr>\n");
       printf ("       </table>\n");
       printf ("       </center>\n");
       break;
     case -2:
       logmessage("RESULT: out of memory\n\n");
       printf ("       <b><font color=\"#ff0000\">Error: can't allocate that much memory. Specify smaller image size or try at a later time.</font></b>\n");
       break;
     case -3:
       logmessage("RESULT: cannot compute Matrn correlation\n\n");
       printf ("       <b><font color=\"#ff0000\">Error: can't compute Matrn correlation with these parameters.</font> Try (10,2).</b>\n");
       break;
    }
  }
 }
 printf("<hr size=2>\n");
 printf("<font size=-2>For source, see <a href=\"http://www.math.umd.edu/~bnk/bak/SOURCE\">http://www.math.umd.edu/~bnk/bak/SOURCE</a>.\n");
 printf("<BR>\n");
 printf("<font size=-2>For Splus version, see <a href=\"http://www.math.umd.edu/~bnk/bak/Splus\">http://www.math.umd.edu/~bnk/bak/Splus</a>.\n");
 printf("<BR>\n");
 printf("      This program uses <a href=\"http://www.fftw.org\">FFTW</a> \n");
 printf("            library by M.Frigo and S.G.Johnson.</font>\n");

 free(r);
 free(g);
 free(b);
 free(c);
 printf("  </body>\n");
 printf("</html>\n");
 return 0;
}
