#include <sys/types.h>
#include <time.h>
#include <fftw.h>
#include "gaussian.h"

int main(int argc, char **argv){
 int i, n1, n2;
 char file_format, *in_filename, *out_filename, s[256];
 double *a, *b, c[100], theta[2];
 int nlevels, red[100], ntheta, em_iterations, gibbs_iterations, use_hooke;
 char covtype;
 if (argc != 2) {
   printf ("Usage: %s ini_file_name\n", argv[0]);
   return -1;
 }
 in_filename=getstring_ini (argv[1], "Discrete data file name");
 file_format=*getstring_ini (argv[1], "Discrete data file format");
 nlevels=getint_ini (argv[1], "nlevels");
 n1=getint_ini  (argv[1],"n1");
 n2=getint_ini  (argv[1], "n2");
 for (i=0; i<nlevels; i++) {
      sprintf (s, "threshold%d", i+1);
      c[i]=getdouble_ini (argv[1], s);
      sprintf (s, "code%d", i+1);
      red[i]=getint_ini (argv[1], s);
   }
  if (file_format=='p'){
   if (get_constraints_ppm (in_filename, &n1, &n2, nlevels, c, red, &a, &b)){
      printf ("Can't read file '%s'\n",in_filename);
      return -1;
   }
  }
  else{
   if (get_constraints_num (in_filename, file_format, n1, n2,
          nlevels, c, red, &a, &b)){
      printf ("Can't read file '%s'\n",in_filename);
      return -1;
   }
 }

 covtype=*getstring_ini (argv[1], "covtype");
 switch (covtype){
  case 's': ntheta=1; break;
  case 'm': ntheta=2; break;
  case 'e': ntheta=2; break;
  case 'r': ntheta=2; break;
  default: printf ("Unknown covariance type '%c'\n", covtype);
           return -1;
 }
 theta[0]=getdouble_ini (argv[1], "theta1");
 theta[1]=getdouble_ini (argv[1], "theta2");
 em_iterations=getint_ini (argv[1], "em_steps");
 gibbs_iterations=getint_ini (argv[1], "gibbs_iterations");
 out_filename=getstring_ini (argv[1], "log file name");
 use_hooke=getint_ini (argv[1], "optimization");
 printf ("[%d]\n", use_hooke);
 srand48(time(NULL));
 EM(a, b, n1, n2, gibbs_iterations, em_iterations,
       covtype, &theta[0], ntheta, use_hooke, out_filename);
 free(a);
 free(b);
 printf ("Created file '%s'\n", out_filename);
 return 0;
}
