#include <string.h>
#include <fftw.h>
#include "gaussian.h"

int input_string (char *prompt, char *s) {
     char buf[1024];
     printf("%s [%s]: ", prompt, s);
     strcpy(buf, s);
     gets(s);
     if (!s[0]) strcpy(s, buf);
     return 0;
}

int input_int (char *prompt, int deft) {
  int response;
  int n;
  char s[1024];
  printf("%s [%d]: ", prompt, deft);
  gets(s);
  response=sscanf(s, "%d",&n);
  if (!response || (response==EOF)) return deft;
  else return n;
}



char input_file_format (char *prompt, char deft) {
     char s[1024];
     printf("%s [%c]: ", prompt, deft);
     gets(s);
     if ((s[0]=='3') || (s[0]=='Z'))
      return s[0];
     else return deft;
}


int main(int argc, char **argv){
 int n1, n2;
 char file_format;
 FFTW_COMPLEX *field;
 char in_filename[256], out_filename[256];
 input_string("Input file name", (char *) strcpy(in_filename,
                     argc>=2 ? argv[1] : "none"));
 file_format=input_file_format("File format (<3> for X Y Z values, <Z> for Z values alone)",'3');
 if (argc>=3) strcpy(out_filename,argv[2]);
   else strcat(strcpy(out_filename, in_filename), ".ppm");
 input_string("Output file name", out_filename);
 n1=input_int ("Grid height", 256);
 n2=input_int ("Grid width", n1);
 field=(FFTW_COMPLEX *) malloc(n1*n2*sizeof(FFTW_COMPLEX));
 if (read_numeric (field, 0, file_format, in_filename, n1, n2)) {
    printf ("Can't read file '%s'\n", in_filename);
    exit(0);
 }
 write_ppm(field, 0, out_filename, n1, n2);
 printf ("Created file '%s'\n",out_filename);
 return 0;
}
